'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (_ref) {
  var _ref$authenticated = _ref.authenticated,
      authenticated = _ref$authenticated === undefined ? DEFAULT_OPTIONS.authenticated : _ref$authenticated,
      _ref$csrf = _ref.csrf,
      csrf = _ref$csrf === undefined ? DEFAULT_OPTIONS.csrf : _ref$csrf,
      _ref$tokenName = _ref.tokenName,
      tokenName = _ref$tokenName === undefined ? DEFAULT_OPTIONS.tokenName : _ref$tokenName,
      _ref$onUnauthorized = _ref.onUnauthorized,
      onUnauthorized = _ref$onUnauthorized === undefined ? DEFAULT_OPTIONS.onUnauthorized : _ref$onUnauthorized,
      _ref$root = _ref.root,
      root = _ref$root === undefined ? DEFAULT_OPTIONS.root : _ref$root;


  return function () {
    return function (next) {
      return function (action) {

        // ignore undefined or null actions
        if (!action) return;

        var lpApi = action[_LP_API2.default];

        // Do not process actions without a [LP_API] property
        if (typeof lpApi === 'undefined') {
          return next(action);
        }

        var types = lpApi.types,
            endpoint = lpApi.endpoint,
            method = lpApi.method,
            body = lpApi.body,
            _lpApi$requestAuthent = lpApi.requestAuthenticated,
            requestAuthenticated = _lpApi$requestAuthent === undefined ? authenticated : _lpApi$requestAuthent,
            rest = _objectWithoutProperties(lpApi, ['types', 'endpoint', 'method', 'body', 'requestAuthenticated']);

        var _types = _slicedToArray(types, 3),
            requestType = _types[0],
            successType = _types[1],
            errorType = _types[2];

        next({
          type: requestType,
          payload: rest
        });

        var url = (root ? root : '') + endpoint;

        var requestOptions = {
          authenticated: requestAuthenticated,
          body: body,
          csrf: csrf,
          method: method,
          tokenName: tokenName
        };

        return (0, _http2.default)(url, requestOptions).then(function (response) {
          return next({
            type: successType,
            payload: _extends({}, rest, { response: response })
          });
        }).catch(function (error) {
          var response = error.response || error.message || 'There was an error.';
          next({
            type: errorType,
            payload: _extends({}, rest, { response: response }),
            error: true
          });
          if (error.status === 401 && onUnauthorized) {
            next(onUnauthorized());
          }
        });
      };
    };
  };
};

var _LP_API = require('./LP_API');

var _LP_API2 = _interopRequireDefault(_LP_API);

var _http = require('./http');

var _http2 = _interopRequireDefault(_http);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DEFAULT_OPTIONS = {
  // http
  authenticated: false,
  csrf: true,
  tokenName: 'token',
  // middleware
  onUnauthorized: null,
  root: null
};